SafeShifter< false > Class Template Reference

Shifts a value in the absence of overflow. More...

## Static Public Member Functions

template<class T >
static T | RightShift (T value, unsigned int bits)
| Right shifts a value that does not overflow. More...
template<class T >
static T | LeftShift (T value, unsigned int bits)
| Left shifts a value that does not overflow. More...

## Detailed Description

### template<>
class SafeShifter< false >

Shifts a value in the absence of overflow.

the `false` template parameter indicates overflow would not occur. In this case, SafeShifter returns the shfted value.

Definition at line 2316 of file misc.h.

## Member Function Documentation

## RightShift()

template<class T >

static T SafeShifter< false >::RightShift | ( | T | value,
|  | unsigned int | bits
| ) |  |

inline static

Right shifts a value that does not overflow.

Template Parameters

  T | class or type

Returns
  the shifted value

Since `overflow == false`, the shifted value is returned.

See also
  SafeLeftShift

Definition at line 2324 of file misc.h.

## LeftShift()

template<class T >

static T SafeShifter< false >::LeftShift | ( | T | value,
|  | unsigned int | bits
| ) |  |

inline static

Left shifts a value that does not overflow.

Template Parameters

  T | class or type

Returns
  the shifted value

Since `overflow == false`, the shifted value is returned.

See also
  SafeRightShift

Definition at line 2335 of file misc.h.

The documentation for this class was generated from the following file:

- misc.h